#include <stdio.h>
#include <unistd.h>
#include <time.h>

#include "libstaf.h"

//just a test of all functions...

int main (int argc, char *argv[])
{
	int fd;
	int a;
	
	uint8_t cs,second,minute,hour,day,month;
	uint16_t year;
	uint8_t event=0;
	uint8_t mode;
	uint8_t running;
	uint8_t alarm;
	uint8_t value[3]={2,1,0};
	uint8_t swminor,swmajor;
	uint8_t pinout[8];
	uint32_t display;
	uint8_t digit;
	float f;
	uint8_t error;
	int16_t calibration;
	
	time_t t;
	struct tm *now;
	
	
	fd = stafConnect("/dev/ttyS0");
	printf("Connect: %d\n",fd);
	
	if(fd<0)
		return fd;
	
	a = stafSetBuzzerMode(fd, NULL, buzzer_disabled);
	printf("Set buzzer: %d\n",a);
	
	a = stafSetCalibration (fd, NULL, -255, 1);
	printf("Set calibration: %d\n",a);
	
	a = stafGetCalibration (fd, NULL, &calibration, 1);
	printf("Get calibration: %d\n",a);
	if(!a)
		printf("%hd\n",calibration);
	
	a = stafSetCalibration (fd, NULL, 0, 1);
	printf("Set calibration: %d\n",a);
	
	a = stafGetCalibration (fd, NULL, &calibration, 1);
	printf("Get calibration: %d\n",a);
	if(!a)
		printf("%hd\n",calibration);
	
	a = stafGetPinout(fd, NULL, pinout);
	printf("Get pinout: %d\n",a);
	if(!a)
		printf("%02hhx %02hhx %02hhx %02hhx %02hhx %02hhx %02hhx %02hhx\n",pinout[0],pinout[1],pinout[2],pinout[3],pinout[4],pinout[5],pinout[6],pinout[7]);
	
	a = stafSetDisplay(fd, NULL, pinout,
		segment_n3 | segment_ne3 | segment_mid3 | segment_nw3 |
		segment_n2 | segment_ne2 | segment_mid2 | segment_nw2);
	printf("Set display: %d\n",a);
	usleep(300000);
	
	a = stafSetDisplay(fd, NULL, pinout,
		segment_n1 | segment_ne1 | segment_mid1 | segment_nw1 |
		segment_n2 | segment_ne2 | segment_mid2 | segment_nw2);
	printf("Set display: %d\n",a);
	usleep(300000);
	
	a = stafSetDisplay(fd, NULL, pinout,
		segment_n1 | segment_ne1 | segment_mid1 | segment_nw1 |
		segment_n0 | segment_ne0 | segment_mid0 | segment_nw0);
	printf("Set display: %d\n",a);
	usleep(300000);
	
	a = stafSetDisplay(fd, NULL, pinout,
		segment_s1 | segment_se1 | segment_mid1 | segment_sw1 |
		segment_s0 | segment_se0 | segment_mid0 | segment_sw0);
	printf("Set display: %d\n",a);
	usleep(300000);
	
	a = stafSetDisplay(fd, NULL, pinout,
		segment_s1 | segment_se1 | segment_mid1 | segment_sw1 |
		segment_s2 | segment_se2 | segment_mid2 | segment_sw2 |
		dot_alarm);
	printf("Set display: %d\n",a);
	usleep(300000);
	
	a = stafSetDisplay(fd, NULL, pinout,
		segment_s3 | segment_se3 | segment_mid3 | segment_sw3 |
		segment_s2 | segment_se2 | segment_mid2 | segment_sw2 |
		dot_alarm);
	printf("Set display: %d\n",a);
	usleep(300000);
	
	
	a = stafFreeDisplay(fd, NULL);
	printf("Free display: %d\n",a);
	
	a = stafSetTime(fd, NULL, 45, 23, 0);
	printf("Set time: %d\n",a);
	
	a = stafSetDate(fd, NULL, 12, 3, 1);
	printf("Set date: %d\n",a);
	
	a = stafSetYear(fd, NULL, 1998, 1);
	printf("Set year: %d\n",a);
	
	a = stafGetTime(fd, NULL, &cs, &second, &minute, &hour, &day, &month, &year);
	printf("Get time: %d\n",a);
	if(!a)
		printf("%02hhu:%02hhu:%02hhu.%02hhu, %02hhu.%02hhu.%04hu\n",hour,minute,second,cs,day,month,year);
	
	a = stafGetMode(fd, NULL, &mode);
	printf("Get mode: %d\n",a);
	printf("%02hhx\n",mode);
	
	a = stafSetValue(fd, NULL, value);
	printf("Set value: %d\n",a);
	
	a = stafGetValue(fd, NULL, value);
	printf("Get value: %d\n",a);
	if(!a)
		printf("%02hhx %02hhx %02hhx\n",value[0],value[1],value[2]);
	
	a = stafSetCountdown (fd, NULL, 2, 0, 0);
	printf("Set countdown: %d\n",a);
	
	a = stafIsRunning(fd, NULL, &running);
	printf("Is running: %d\n",a);
	if(!a)
		printf("%s\n",running?"run":"stop");
	
	a = stafSetRunning(fd, NULL, !running);
	printf("Set running: %d\n",a);
	
	a = stafIsRunning(fd, NULL, &running);
	printf("Is running: %d\n",a);
	if(!a)
		printf("%s\n",running?"run":"stop");
	
	a = stafGetVersion(fd, NULL, &swminor, &swmajor);
	printf("Get version: %d\n",a);
	if(!a)
		printf("%hhu.%hhu\n",swmajor,swminor);
	
	a = stafGetDisplay(fd, NULL, pinout, &display);
	printf("Get display: %d\n",a);
	if(!a)
	{
		printf("    %c   %c     %c   %c\n",(display&segment_n3)?'-':' ',(display&segment_n2)?'-':' ',(display&segment_n1)?'-':' ',(display&segment_n0)?'-':' ');
		printf("   %c %c %c %c %c %c %c %c %c\n",(display&segment_nw3)?'|':' ',(display&segment_ne3)?'|':' ',(display&segment_nw2)?'|':' ',(display&segment_ne2)?'|':' ',(display&dot_top)?'.':' ',(display&segment_nw1)?'|':' ',(display&segment_ne1)?'|':' ',(display&segment_nw0)?'|':' ',(display&segment_ne0)?'|':' ');
		printf("    %c   %c     %c   %c\n",(display&segment_mid3)?'-':' ',(display&segment_mid2)?'-':' ',(display&segment_mid1)?'-':' ',(display&segment_mid0)?'-':' ');
		printf(" %c %c %c %c %c %c %c %c %c %c\n",(display&dot_alarm)?'.':' ',(display&segment_sw3)?'|':' ',(display&segment_se3)?'|':' ',(display&segment_sw2)?'|':' ',(display&segment_se2)?'|':' ',(display&dot_bottom)?'.':' ',(display&segment_sw1)?'|':' ',(display&segment_se1)?'|':' ',(display&segment_sw0)?'|':' ',(display&segment_se0)?'|':' ');
		printf("    %c   %c     %c   %c\n",(display&segment_s3)?'-':' ',(display&segment_s2)?'-':' ',(display&segment_s1)?'-':' ',(display&segment_s0)?'-':' ');
		printf("%08lx\n",display);
	}
	
	a = stafSubscribeEvent (fd, &event, event_tick | event_button_c);
	printf("Sub. event: %d\n",a);
	
	a = stafTriggerEvent (fd, &event, event_button_c);
	printf("Trigger event: %d\n",a);
	
	a = stafSubscribeEvent (fd, &event, 0);
	printf("Unsub. event: %d\n",a);
	if(!a)
		printf("%hhx\n",event);
	
	a = stafSetDigit(fd, NULL, 2);
	printf("Set digit: %d\n",a);
	
	a = stafGetDigit(fd, NULL, &digit);
	printf("Get digit: %d\n",a);
	if(!a)
		printf("%hhu\n",digit);
	
	a = stafSetDigitValue(fd, NULL, 1);
	printf("Set digit value: %d\n",a);
	
	a = stafGetDigitValue (fd, NULL, &digit);
	printf("Get digit value: %d\n",a);
	if(!a)
		printf("%hhu\n",digit);
	
	sleep(2);
	
	a = stafConfirm(fd, NULL);
	printf("Confirm: %d\n",a);
	
		a = stafSetAlarm(fd, NULL, 34, 13, 1);
	printf("Set alarm: %d\n",a);
	
	a = stafGetAlarm(fd, NULL, &alarm, &minute, &hour);
	printf("Get alarm: %d\n",a);
	if(!a)
		printf("%hhu %hhu:%hhu\n",alarm,hour,minute);
	
	a = stafClearAlarm(fd, NULL, 1);
	printf("Clear alarm: %d\n",a);
	
	a = stafGetAlarm(fd, NULL, &alarm, &minute, &hour);
	printf("Get alarm: %d\n",a);
	if(!a)
		printf("%hhu %hhu:%hhu\n",alarm,hour,minute);
	
	a = stafCalculate(fd, NULL, -10.0, 0.12, calc_multiply, &f, &error, 1);
	printf("Calculate: %d\n",a);
	if(!a)
		printf("%s %f\n",error?"ERR":"OK",f);
	
	a = stafCalculate(fd, NULL, 1234.0, 0.0, calc_divide, &f, &error, 1);
	printf("Calculate: %d\n",a);
	if(!a)
		printf("%s %f\n",error?"ERR":"OK",f);
	
	a = stafSetDebugValue(fd, NULL, 0x31, 0xee, 1);
	printf("Set dbg: %d\n",a);
	
	a = stafGetDebugValue(fd, NULL, 0x31, &digit, 1);
	printf("Get dbg: %d\n",a);
	if(!a)
		printf("%hhx\n",digit);
	
	
	a = stafSetMode(fd, NULL, mode_alarm);
	printf("Alarm: %d\n",a);
	
	a = stafWriteMemory(fd, NULL, 0x022f, 0x02);
	printf("Write memory: %d\n",a);
	
	a = stafReadMemory(fd, NULL, 0x022f, &digit); //&digit == 0x022f in sw 2.1
	printf("Read memory: %d\n",a);
	if(!a)
		printf("%hhx\n",digit);
	
	//ok now clean up the time:
	
	time (&t);
	now = localtime (&t);
	
	stafSetTime(fd, NULL, now->tm_min, now->tm_hour, 0);
	stafSetDate(fd, NULL, now->tm_mday, now->tm_mon+1, 0);
	stafSetYear(fd, NULL, now->tm_year+1900, 0);
	stafClearAlarm(fd, NULL, 0);
	
	// usleep(3000000);
	
	a = stafSetMode(fd, NULL, mode_reset);
	printf("Reset: %d\n",a);
	
	
	a = stafDisconnect(fd);
	printf("Disconnect: %d\n",a);
	
	return 0;
}
